from dataclasses import dataclass
from typing import List, Dict, Any
from datetime import datetime


@dataclass
class FieldData:
    irrigations: List[any]
    fertilisations: List[any]
    geometry: any
    startDate: datetime
    endDate: datetime
    country: str
    community: str
    
    @classmethod
    def from_request(cls, data: Dict[str, Any]):
        return cls(
            irrigations=data['irrigations'],
            fertilisations=[treatment for treatment in data['fertilisations'] if treatment['type'] == 'fertilizer'],
            geometry=data['geometry'],
            startDate="2023-01-01T12:00:00.000Z",  # data['startDate'], # Temporary fixed start date
            endDate="2023-12-31T12:00:00.000Z", # data['endDate'],  # Temporary fixed end date
            country=data['country'],
            community=data['community']
        )  

        # TODO: When field startDate and endDate is used, we get below error 
                # 'ValueError: x and y arrays must be equal in length along interpolation axis.'
                # this error occurs also for current year even 1 jan is given as startDate because meteo data is less than 365